// File:          Neuron.hpp
// Date:          January 2017
// Author:        Sanalitro

#ifndef INPUTNEURON_HPP
#define INPUTNEURON_HPP

#include <cmath>
#include <iostream>

using namespace std;

/*
 * Classe che implementa il modello di un neurone di Izhikevich con classe di
 * eccitabilità 2 (scarsa dipendenza della frequenza di spike dall'ampiezza
 * dell'input). Questi neuroni verranno impiegati in batteria per i primi due
 * layer della rete per il Body Size Learning.
 */
class  InputNeuron
{

private:
	double a, b, c, d, Ibias, deltaT;

public:
	InputNeuron(double deltaT);
	virtual ~InputNeuron();

	int simulate(double sinapticInput, double v0, double u0, double *v, double *u); // returns 1 if the neuron emitted a spike, 0 otherwise
};

#endif
