// File:          OutputNeuron.hpp
// Date:          January 2018
// Author:        Sanalitro

#ifndef OUTPUTNEURON_HPP
#define OUTPUTNEURON_HPP

#include <iostream>

using namespace std;

/*
 * Classe che implementa il modello di un neurone di Izhikevich con classe di
 * eccitabilità 1. Questo neurone è l'unico neurone di output della rete per il
 * Body Size Learning.
 */
class  OutputNeuron
{

private:
	double a, b, c, d, Ibias, gA, Vth, deltaVth, deltaT;

public:
	OutputNeuron(double deltaT);
	OutputNeuron(double deltaT, double Vth);
	OutputNeuron(double deltaT, double Vth, double deltaVth);
	~OutputNeuron();

	double getVth();

	int simulate(double sinapticInput, double v0, double u0, double *v, double *u); // returns 1 if the neuron emitted a spike, 0 otherwise

	double update(bool isTaken, bool isFiring);
};

#endif
